﻿-- Pare.lua

-----------------------------------------------------------------------------------
-- Initializing variables
-----------------------------------------------------------------------------------
if (parechannel == nil) then parechannel = "EMOTE"; end	
if (showskill == nil) then showskill = 1; end
if (showtarget == nil) then showtarget = 0; end
if (pareenabled == nil) then pareenabled = 1; end
-----------------------------------------------------------------------------------

local Pare = CreateFrame('FRAME');

Pare:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
Pare:SetScript("OnEvent", function(self, event)
	self:OnEvent(event, CombatLogGetCurrentEventInfo())
end)

function Pare:OnEvent(event, ...)
	if (pareenabled == 0) then return end
	
	local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15 = ...	
	
	if arg2 ~= "SPELL_INTERRUPT" then return end
	if arg5 ~= UnitName("player") then return end
	
	-- Adjust the verbose on the interrupted text for when it's announced on /e
	verbose = "Interrupted ";
	if (parechannel == "EMOTE") then verbose = "interrupted " end
	
	-- Error handling
	local name, instanceType, difficultyID, difficultyName, maxPlayers, dynamicDifficulty, isDynamic, instanceID, instanceGroupSize, LfgDungeonID = GetInstanceInfo()
	errormsg = ""
	if (parechannel == "INSTANCE_CHAT") then inInstance, instanceType = IsInInstance(); if (inInstance == false) then allowed = 0; errormsg = " (Error: You are not in an instance)." end end
	if (parechannel == "SAY") then if (instanceType == "none") then allowed = 0; errormsg = " (Error: You are not allowed announce to /s right now)." end end
	if (parechannel == "YELL") then if (instanceType == "none") then allowed = 0; errormsg = " (Error: You are not allowed to announce on /y right now)." end end
	if (parechannel == "PARTY") then if (instanceType ~= "party") then allowed = 0; errormsg = " (Error: You are not in a party)." end end
	if (parechannel == "RAID") then if (instanceType ~= "raid") then allowed = 0; errormsg = " (Error: You are not in a raid)." end end
	if (parechannel == "GUILD") then guildName, guildRankName, guildRankIndex = GetGuildInfo("player"); if (guildName == nil) then allowed = 0; errormsg = " (Error: You are not in a guild)." end end
	if (parechannel == "OFFICER") then guildName, guildRankName, guildRankIndex = GetGuildInfo("player"); if (guildName == nil) then allowed = 0; errormsg = " (Error: You are not in a guild)." end end
	
	-- Announcement conditional
	if (showtarget == 1) then
		if (showskill == 1) then
			local output = verbose .. arg9 .. "'s " .. GetSpellLink(arg15) .. " using " .. GetSpellLink(arg12) .. "!" .. errormsg;
			if (parechannel == "SELF" or allowed == 0) then print(output) return end
			SendChatMessage(output, parechannel)
			else
			local output = verbose .. arg9 .. "'s " .. GetSpellLink(arg15) .. "!" .. errormsg;
			if (parechannel == "SELF" or allowed == 0) then print(output) return end
			SendChatMessage(output, parechannel)
		end
		
		else
		if (showskill == 1) then
			local output = verbose .. GetSpellLink(arg15) .. " using " .. GetSpellLink(arg12) .. "!" .. errormsg;
			if (parechannel == "SELF" or allowed == 0) then print(output) return end
			SendChatMessage(output, parechannel)
			else 
			local output = verbose .. GetSpellLink(arg15) .. "!" .. errormsg;
			if (parechannel == "SELF" or allowed == 0) then print(output) return end
			SendChatMessage(output, parechannel)
		end
	end
	
	
end

-- Slash Commands
SLASH_PARE1, SLASH_PARE2 = '/pare', '/pare!';
function SlashCmdList.PARE(msg, editbox)
	if (msg == "self") then parechannel = "SELF"; print("Pare will now announce on your screen only."); return end
	if (msg == "emote") then parechannel = "EMOTE"; print("Pare will now announce the interrupt on /emote."); return end
	if (msg == "party") then parechannel = "PARTY"; print("Pare will now announce the interrupt on /party."); return end
	if (msg == "raid") then parechannel = "RAID"; print("Pare will now announce the interrupt on /raid."); return end
	if (msg == "rw") then parechannel = "RAID_WARNING"; print("Pare will now announce the interrupt on /rw."); return end
	if (msg == "instance") then parechannel = "INSTANCE_CHAT"; print("Pare will now announce the interrupt on /i."); return end
	if (msg == "guild") then parechannel = "GUILD"; print("Pare will now announce the interrupt on /guild."); return end
	if (msg == "officer") then parechannel = "OFFICER"; print("Pare will now announce the interrupt on /officer."); return end
	if (msg == "yell") then parechannel = "YELL"; print("Pare will now announce the interrupt on /yell. This option will not work while not on an instanced dungeon or a battleground."); return end
	if (msg == "say") then parechannel = "SAY"; print("Pare will now announce the interrupt on /s. This option will not work while not on an instanced dungeon or a battleground."); return end
	if (msg == "showskill") then if (showskill == 0) then showskill = 1; print("The spell/ability you use to interrupt will be shown."); return else showskill = 0; print("The spell/ability you use to interrupt will no longer be shown."); return end end
	if (msg == "showtarget") then  if (showtarget == 0) then showtarget = 1; print("The interrupted target's name will now be shown in the message."); return else showtarget = 0; print("The interrupted target's name will no longer be shown in the message."); return end end
	
	if (msg == "enable") then
		pareenabled = 1;
		print("Pare is now enabled.");
		return
	end
	
	if (msg == "disable") then
		pareenabled = 0;	
		print("Pare is now disabled.");
		return
	end
	
	if (msg == "help") then 
		print("----------------------------------------------------------");
		print("Pare - Interrupt Announcer - Slash commands");
		print("----------------------------------------------------------");
		print("/pare emote - Announce on /e.");
		print("/pare party - Announce on /p.");
		print("/pare raid - Announce on /r.");
		print("/pare rw - Announce on /rw.");
		print("/pare instance - Announce on /i.");
		print("/pare guild - Announce on /g.");
		print("/pare officer - Announce on /o.");
		print("/pare yell - Announce on /y (Ps.: This does not work outside of group content).");
		print("/pare say - Announce on /s. (Ps.: This does not work outside of group content)");
		print("/pare self - Announce locally (your screen only).");
		print("/pare showskill - Show interrupted spell/ability name on the message.");
		print("/pare showtarget - Show the interrupted target's name on the message.");
		print("/pare enable - Enables the addon.");
		print("/pare disable - Disables the addon.");
	return end
	
	
	print("----------------------------------------------------------");
	print ("Pare - Interrupt Announcer");
	print ("For help type /pare help");
	print("----------------------------------------------------------");
	print ("Current config:");
	print("----------------------------------------------------------");
	if (pareenabled == 0) then print("The addon is currently DISABLED. No messages will be shown."); return end
	if (parechannel == "EMOTE") then print("Announce on: /emote"); end
	if (parechannel == "SELF") then print("Announcing on your screen only."); end
	if (parechannel == "PARTY") then print("Announce on: /party"); end
	if (parechannel == "RAID") then print("Announce on: /raid"); end
	if (parechannel == "RAID_WARNING") then print("Announce on: /rw"); end
	if (parechannel == "INSTANCE_CHAT") then print("Announce on: /instance"); end
	if (parechannel == "GUILD") then print("Announce on: /guild"); end
	if (parechannel == "OFFICER") then print("Announce on: /officer"); end
	if (parechannel == "SAY") then print("Announce on: /say (This will not work while on the open world)"); end 
	if (parechannel == "YELL") then print("Announce on: /yell (This will not work while on the open world)"); end	
	if (showskill == 1) then print("Your interrupt ability or spell will be shown."); end
	if (showtarget == 1) then print("The interrupted target's name will be shown."); end
	print("----------------------------------------------------------");
end
